#include <stdlib.h>
#include <stdio.h>

int hex(char *p)
{
	int i,j;
	i=*(p++)-48;
	if (i>9) i-=7;
	j=*p-48;
	if (j>9) j-=7;
	i=(i<<4)|j;
	return(i);
}

main(argc,argv)
int argc;
char *argv[];
{
	unsigned int i,j,nd,nc,f=0;
	unsigned long dir,odir,li;
	char buff[256];
	FILE *fi,*fo;

	if (argc<3) {
		fprintf(stderr,"Uso :s2bin <fichero.S> <fichero.bin>\n\n");
		exit(0);
	}
	if ((fi=fopen(argv[1],"r"))==NULL) {
		fprintf(stderr,"No se pudo abrir fichero %s\n\n",argv[1]);
		exit (0);
	}
	if ((fo=fopen(argv[2],"wb"))==NULL) {
		fprintf(stderr,"No se pudo crear fichero %s\n\n",argv[2]);
		exit(0);
	}

	for (;;) {
		fgets(buff,256,fi);
		if (buff[0]!='S') {
			fprintf(stderr,"Fichero con formato ilegal :%s\n\n",argv[1]);
			exit (0);
		}
		nd=buff[1]-48;
		if (nd==0) continue;
		if (nd==9) break;
		nd++;			/* N de digitos de direccin */
		nc=hex(buff+2)-nd-1;    /* N de bytes de la linea */
		i=4;
		dir=0;
		for (j=0;j<nd;j++) {
			dir<<=8;
			dir|=hex(buff+i);
			i+=2;
		}
		if (f>0) {
			if (odir<dir) {
				printf("Rellenando %ld bytes\n",dir-odir);
				for (li=0;li<(dir-odir);li++) putc(0,fo);
			}
			if (odir>dir) {
				fprintf(stderr,"ERROR, este programa slo admite bloques en orden creciente\n\n");
				exit(0);
			}
		}
		f=1;
		odir=dir+nc;
		printf("%08lx\n",dir);
		for (j=0;j<nc;j++) {
			putc(hex(buff+i),fo);
			i+=2;
		}
	}
	fclose(fi);
	fclose(fo);
}
